import { describe, expect, test } from 'vitest';
import { parseTreeResultsAsList } from '../src';

const sdmxJson = {
  data: {
    schemes: [
      { id: '0', agencyID: 'SIS-CC', version: 'x.x' },
      { id: '1', name: 'L1', items: [], agencyID: 'SIS-CC', version: 'x.x' },
      {
        id: '2',
        agencyID: 'SIS-CC',
        version: 'x.x',
        items: [{ id: 'A' }, { id: 'B', name: 'L2VB' }, { id: 'C' }],
      },
      {
        id: '3',
        name: 'L3',
        agencyID: 'SIS-CC',
        version: 'x.x',
        items: [
          { id: 'A', name: 'L3VA' },
          {
            id: 'B',
            name: 'L3VB',
            items: [
              {
                id: 'A',
                name: 'L3VBA',
                items: [{ id: 'A', name: 'L3VBAA' }],
              },
              { id: 'B', name: 'L3VBB' },
              { id: 'C', name: 'L3VBC' },
              { id: 'D', name: 'L3VBD' },
            ],
          },
          {
            id: 'C',
            name: 'L3VC',
            items: [
              { id: 'A', name: 'L3VCA' },
              { id: 'B', name: 'L3VCB' },
            ],
          },
        ],
      },
    ],
  },
};

const expected = {
  'SIS-CC:0(x.x)': {
    id: 'SIS-CC:0(x.x)',
    code: '0',
    hierarchicalCode: '0',
    label: undefined,
    agencyId: 'SIS-CC',
    version: 'x.x',
  },
  'SIS-CC:1(x.x)': {
    id: 'SIS-CC:1(x.x)',
    code: '1',
    hierarchicalCode: '1',
    label: 'L1',
    agencyId: 'SIS-CC',
    version: 'x.x',
  },
  'SIS-CC:2(x.x)': {
    id: 'SIS-CC:2(x.x)',
    code: '2',
    hierarchicalCode: '2',
    label: undefined,
    agencyId: 'SIS-CC',
    version: 'x.x',
  },
  'SIS-CC:2(x.x).A': {
    id: 'SIS-CC:2(x.x).A',
    code: 'A',
    hierarchicalCode: 'A',
    label: undefined,
    agencyId: undefined,
    version: undefined,
    parentId: 'SIS-CC:2(x.x)',
    topParentId: 'SIS-CC:2(x.x)',
  },
  'SIS-CC:2(x.x).B': {
    id: 'SIS-CC:2(x.x).B',
    code: 'B',
    hierarchicalCode: 'B',
    label: 'L2VB',
    agencyId: undefined,
    version: undefined,
    parentId: 'SIS-CC:2(x.x)',
    topParentId: 'SIS-CC:2(x.x)',
  },
  'SIS-CC:2(x.x).C': {
    id: 'SIS-CC:2(x.x).C',
    code: 'C',
    hierarchicalCode: 'C',
    label: undefined,
    agencyId: undefined,
    version: undefined,
    parentId: 'SIS-CC:2(x.x)',
    topParentId: 'SIS-CC:2(x.x)',
  },
  'SIS-CC:3(x.x)': {
    id: 'SIS-CC:3(x.x)',
    code: '3',
    hierarchicalCode: '3',
    label: 'L3',
    agencyId: 'SIS-CC',
    version: 'x.x',
  },
  'SIS-CC:3(x.x).A': {
    id: 'SIS-CC:3(x.x).A',
    code: 'A',
    hierarchicalCode: 'A',
    label: 'L3VA',
    agencyId: undefined,
    version: undefined,
    parentId: 'SIS-CC:3(x.x)',
    topParentId: 'SIS-CC:3(x.x)',
  },
  'SIS-CC:3(x.x).B': {
    id: 'SIS-CC:3(x.x).B',
    code: 'B',
    hierarchicalCode: 'B',
    label: 'L3VB',
    agencyId: undefined,
    version: undefined,
    parentId: 'SIS-CC:3(x.x)',
    topParentId: 'SIS-CC:3(x.x)',
  },
  'SIS-CC:3(x.x).B.A': {
    id: 'SIS-CC:3(x.x).B.A',
    code: 'A',
    hierarchicalCode: 'B.A',
    label: 'L3VBA',
    agencyId: undefined,
    version: undefined,
    parentId: 'SIS-CC:3(x.x).B',
    topParentId: 'SIS-CC:3(x.x)',
  },
  'SIS-CC:3(x.x).B.A.A': {
    id: 'SIS-CC:3(x.x).B.A.A',
    code: 'A',
    hierarchicalCode: 'B.A.A',
    label: 'L3VBAA',
    agencyId: undefined,
    version: undefined,
    parentId: 'SIS-CC:3(x.x).B.A',
    topParentId: 'SIS-CC:3(x.x)',
  },
  'SIS-CC:3(x.x).B.B': {
    id: 'SIS-CC:3(x.x).B.B',
    code: 'B',
    hierarchicalCode: 'B.B',
    label: 'L3VBB',
    agencyId: undefined,
    version: undefined,
    parentId: 'SIS-CC:3(x.x).B',
    topParentId: 'SIS-CC:3(x.x)',
  },
  'SIS-CC:3(x.x).B.C': {
    id: 'SIS-CC:3(x.x).B.C',
    code: 'C',
    hierarchicalCode: 'B.C',
    label: 'L3VBC',
    agencyId: undefined,
    version: undefined,
    parentId: 'SIS-CC:3(x.x).B',
    topParentId: 'SIS-CC:3(x.x)',
  },
  'SIS-CC:3(x.x).B.D': {
    id: 'SIS-CC:3(x.x).B.D',
    code: 'D',
    hierarchicalCode: 'B.D',
    label: 'L3VBD',
    agencyId: undefined,
    version: undefined,
    parentId: 'SIS-CC:3(x.x).B',
    topParentId: 'SIS-CC:3(x.x)',
  },
  'SIS-CC:3(x.x).C': {
    id: 'SIS-CC:3(x.x).C',
    code: 'C',
    hierarchicalCode: 'C',
    label: 'L3VC',
    agencyId: undefined,
    version: undefined,
    parentId: 'SIS-CC:3(x.x)',
    topParentId: 'SIS-CC:3(x.x)',
  },
  'SIS-CC:3(x.x).C.A': {
    id: 'SIS-CC:3(x.x).C.A',
    code: 'A',
    hierarchicalCode: 'C.A',
    label: 'L3VCA',
    agencyId: undefined,
    version: undefined,
    parentId: 'SIS-CC:3(x.x).C',
    topParentId: 'SIS-CC:3(x.x)',
  },
  'SIS-CC:3(x.x).C.B': {
    id: 'SIS-CC:3(x.x).C.B',
    code: 'B',
    hierarchicalCode: 'C.B',
    label: 'L3VCB',
    agencyId: undefined,
    version: undefined,
    parentId: 'SIS-CC:3(x.x).C',
    topParentId: 'SIS-CC:3(x.x)',
  },
};

describe('parseTreeResultsAsList', () => {
  test('complete case', () => {
    expect(parseTreeResultsAsList({ lists: 'schemes', listValues: 'items' })(sdmxJson)).toEqual(
      expected,
    );
  });
});
